<?php
/**
 *
 */

class plgHikashopDpdpickup extends JPlugin
{
	/**
	 *
	 */
	private $pudo_id;
	private $pudo_address1;
	private $pudo_name;
	private $pudo_zipcode;
	private $pudo_city;

	public function __construct(&$subject, $config) {
		parent::__construct($subject, $config);

		$this->loadLanguage('plg_hikashop_dpdpickup', JPATH_ADMINISTRATOR );
		$this->pudo_id='';
		$this->pudo_address1='';
		$this->pudo_name='';
		$this->pudo_zipcode='';
		$this->pudo_city ='';
	}

	/**
	 *
	 */
	public function setPudoId($pudo_id)
	{
		$this->pudo_id = $pudo_id;
	}
	public function setPudoName($pudo_name)
	{
		$this->pudo_name = $pudo_name;
	}
	public function setPudoAddress1($pudo_address1)
	{
		$this->pudo_address1 = $pudo_address1;
	}
	public function setPudoZipcode($pudo_zipcode)
	{
		$this->pudo_zipcode = $pudo_zipcode;
	}
	public function setPudoCity($pudo_city)
	{
		$this->pudo_city = $pudo_city;
	}
	public function onFieldsLoad(&$fields, &$options) {
		$me = new stdClass();
		$me->name = 'dpdpickup';
		$me->text = 'Sélecteur point relais DPD';
		$me->options = array('required', 'default', 'columnname', 'format', 'allow', 'dpdpickup_options');

		$fields[] = $me;

		$opt = new stdClass();
		$opt->name = 'dpdpickup_options';
		$opt->text = 'Point relais DPD';
		

		$options[$opt->name] = $opt;

	}
	public function displayPickupPoints() {
		$DPDFrance= new DPDFrance;
		$app = JFactory::getApplication();
		$shipping_address = $app->getUserState( HIKASHOP_COMPONENT.'.shipping_address');
		$addressClass = hikashop_get('class.address');
		$shipping_address_data = $addressClass->get($shipping_address);
		$adresse_street = $shipping_address_data->address_street;
		$address_post_code = $shipping_address_data->address_post_code;
		$adresse_city = $shipping_address_data->address_city;
		$relais_list = DPDFrance::getPickupPoints($adresse_street, $address_post_code, $adresse_city);
		/* Build display: call CSS and create div */
		$html = '<h4>Séléctionnez votre point-relais</h4><div id="dpdfrance_pickup"><form id="dpd_form">';
		/* Write each Pickup point */
		foreach ($relais_list as $offset => $pointRelais)
		{
			$html .= '
			<label>
				<div class="lignepr" id="lignepr'.$offset.'">
					<div class"dpdrelais_logo" id="dpdrelais_logo"><img src="/images/pointrelais.png" alt="Logo DPD Relais" /></div>
					<div class="dpdrelais_info" id="dpdrelais'.$offset.'_info"><span id="shop_name'.$pointRelais['relay_id'].'"><strong>' . $pointRelais['shop_name'] . '</strong></span><br/><span id="address1'.$pointRelais['relay_id'].'">' . $pointRelais['address1'] . '</span> <br/> <span id="zipcode'.$pointRelais['relay_id'].'">' . $pointRelais['zipcode'] . '</span><span id="city'.$pointRelais['relay_id'].'">' . $pointRelais['city'] .'</span></div>
					<div class="dpdrelais_radio"><input type="radio" name="dpdfrance_pickup" value="'.$pointRelais['relay_id'].'"></input></div>
					<div class="dpdrelais_popup"><a href="http://www.dpd.fr/dpdrelais/id_'.$pointRelais['relay_id'].'" target="_blank">Plus de détails</a></div>
					<div class="dpdrelais_distance">' . $pointRelais['distance'] . ' km  <br/> ID: ' . $pointRelais['relay_id'] . '</div>
				</div>
			</label>
			';
		}
		/* Close div */
		$html .= '</form></div>';
		/* Display */
		echo $html;
		return $html;
	}
	/*
	** GetInfoShipping
	** retourne un objet info shipping contenant 
	*/

	function getInfoShipping($shipping_id)
	{
		$db = JFactory::getDbo();
		$query = $db->getQuery(true);
		$query->select('shipping_type, shipping_name');
		$query->from($db->quoteName('#__hikashop_shipping'));
		$query->where($db->quoteName('shipping_id') . ' LIKE '. $db->quote($shipping_id));
		$db->setQuery($query);
		$result = $db->loadObject();
		return $result;
	}

	/*
	** deleteAt
	** retourne un objet info shipping contenant 
	*/
	function deleteAfterAtSymbol($message)
	{
		$pos=strpos($message, "@");
		if ($pos == false)
		{
			return $message;
		}
		else
		{
			$message = substr($message,0,$pos);
			return $message;
		}
	}
	/*
	* Return selected pickup_id
	*
	*/
	public function getInfoPudo()
	{
		$app = JFactory::getApplication();
		$user_id = $app->getUserState(HIKASHOP_COMPONENT.'.user_id');
		$shipping_address = $app->getUserState( HIKASHOP_COMPONENT.'.shipping_address');
		$addressClass = hikashop_get('class.address');
		$address_title = $addressClass->get($shipping_address)->address_title;
		$address_firstname = $addressClass->get($shipping_address)->address_firstname;
		$address_lastname = $addressClass->get($shipping_address)->address_lastname;
		$address_telephone = $addressClass->get($shipping_address)->address_telephone;
		$address_country = $addressClass->get($shipping_address)->address_country;
		$address_state = $addressClass->get($shipping_address)->address_state;
		?>
		<script>jQuery(window).load(function() 
			{
				jQuery('input').each(function()
				{
					jQuery(this).click(function()
					{
						var pickup_id = jQuery(this).val();
						jQuery.ajax(
						{
							url:'',
							data: 'pickup_id='+pickup_id,
							type:'post',
							
						})
					});
				});
			});
		</script>
		<?php
		
		if (isset($_POST['pickup_id']))
		{
			$pudo_id = $_POST['pickup_id'];
			$session =& JFactory::getSession(); 
			$session->set('pudo_id', $pudo_id);
			$mypudo	= file_get_contents('http://mypudo.pickup-services.com/mypudo/mypudo.asmx/GetPudoDetails?pudo_id='.urlencode($pudo_id).'&carrier=EXA&key=deecd7bc81b71fcc0e292b53e826c48f');
			$xml = new SimpleXMLElement($mypudo);
			$pudo_name=$xml->PUDO_ITEMS->PUDO_ITEM->NAME;
			$pudo_address1=$xml->PUDO_ITEMS->PUDO_ITEM->ADDRESS1;
			$pudo_zipcode=$xml->PUDO_ITEMS->PUDO_ITEM->ZIPCODE;
			$pudo_city=$xml->PUDO_ITEMS->PUDO_ITEM->CITY;
			$address_type = $pudo_id;

			// If the pickup is already in db use the address id of this (to test it, check the fieldrow address_type in the hikashop_address table)
			//TO DO
			if ($this->addressExist($user_id, $address_type))
			{
				$app = JFactory::getApplication();
				$app->setUserState(HIKASHOP_COMPONENT.'.shipping_id', $this->addressExist($user_id, $address_type)); 
			}

			//ELSE the pickup isn't in the db, insert a new address associated to the current user_id
			else
			{
				//insert a new address associated to the current user_id
				$this->insertNewAddress($user_id, $address_title, $address_firstname, $address_lastname, $pudo_name, $address_telephone, $pudo_address1, $pudo_zipcode, $pudo_city, $address_state, $address_country, $address_type);
				//affect this new addressid to this order shipping id
				$newadress = $this->addressExist($user_id, $address_type);
				$app = JFactory::getApplication();
				$app->setUserState(HIKASHOP_COMPONENT.'.shipping_id', $this->addressExist($user_id, $address_type));
			}
		}
	}

	// Cette fonction vérifie si l'utilisateur à déjà ce point relais d'enregistré et si non null retourne l'id de l'adresse
	// 
	public function addressExist($user_id, $address_type) 
	{
		$db = JFactory::getDbo();
		$query = $db->getQuery(true);
		$query->select('address_id, address_user_id, address_type');
		$query->from($db->quoteName('#__hikashop_address'));
		$query->where($db->quoteName('address_user_id') . ' LIKE '. $db->quote($user_id). 'AND'. $db->quoteName('address_type') . ' LIKE '. $db->quote($address_type). '');
		$db->setQuery($query);
		echo $query;
		$result = $db->loadResult();
		if (!empty($result))
		{
			return $result;
		}
		else 
		{
			return false;
		}
	}

	public function insertNewAddress($user_id, $address_title, $address_firstname, $address_lastname, $shop_name, $address_telephone, $address1, $zipcode, $city, $address_state, $address_country, $address_type)
	{
		$db = JFactory::getDbo();
		$query = $db->getQuery(true);
		$columns = array('address_user_id', 'address_title','address_firstname', 'address_lastname', 'address_telephone','address_street', 'address_post_code', 'address_city', 'address_state', 'address_country', 'address_type');
		$values = array($db->quote($user_id), $db->quote($address_title), $db->quote($address_firstname.' '.$address_lastname), $db->quote($shop_name), $db->quote($address_telephone), $db->quote($address1), $db->quote($zipcode), $db->quote($city),$db->quote($address_state),$db->quote($address_country), $db->quote($address_type));
		$query
		->insert($db->quoteName('#__hikashop_address'))
		->columns($db->quoteName($columns))
		->values(implode(',', $values));
		$db->setQuery($query);
		$db->execute();
	}

	public function onBeforeCheckoutStep($controller, &$go_back, $original_go_back)
	{
		$app = JFactory::getApplication();
		$shipping_address = $app->getUserState( HIKASHOP_COMPONENT.'.shipping_address');
		$addressClass = hikashop_get('class.address');
		$shipping_address_data = $addressClass->get($shipping_address);
		$this->selected_shipping_id = $app->getUserState(HIKASHOP_COMPONENT.'.shipping_id'); 
		//On récupère l'id du mode de livraison utilisé sous la forme de l'objet hikashop [id@version]
		$shipping_id = $this->deleteAfterAtSymbol($this->selected_shipping_id[0]); 
		// On converti l'id en entier
		$this->selected_shipping_name = $this->getInfoShipping($shipping_id)->shipping_name; 
		// On récupère le nom du mode de livraison.
		if ($this->selected_shipping_name == "DPD FRANCE SAS (point relais)")
		{

			$this->displayPickupPoints();
			$this->getInfoPudo();

		}
	}

	public function onAfterCheckoutStep($controller, &$go_back, $original_go_back)
	{	
		

		$app = JFactory::getApplication();

		$shipping_address = $app->getUserState( HIKASHOP_COMPONENT.'.shipping_address');
		$addressClass = hikashop_get('class.address');
		$shipping_address_data = $addressClass->get($shipping_address);
		
		$this->selected_shipping_id = $app->getUserState(HIKASHOP_COMPONENT.'.shipping_id'); 
		echo $this->selected_shipping_id;
		var_dump($this->order_id);
		

		$orderClass = hikashop_get('class.order');
		//$order = $orderClass->loadFullOrder($order_id, true, false);
		


	}
}

if(defined('HIKASHOP_COMPONENT')) {
/**
*
*/
/*require_once( dirname(__FILE__).DS.'dpdpickup_class.php' );*/
require_once( dirname(__FILE__).DS.'class-dpdfrance.php' );
}